Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 75772)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -2201,47 +2741,53 @@
                 ExReleaseResourceLite(&c->lock);
                 goto end;
             }
-    
+
             RtlCopyMemory(bgi, tp.item->data, tp.item->size);
             bgi->used = c->used;
-            
+
             TRACE("adjusting usage of chunk %llx to %llx\n", c->offset, c->used);
-            
-            delete_tree_item(Vcb, &tp, rollback);
-            
-            if (!insert_tree_item(Vcb, Vcb->extent_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, bgi, tp.item->size, NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
+
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
                 ExFreePool(bgi);
-                Status = STATUS_INTERNAL_ERROR;
                 ExReleaseResourceLite(&c->lock);
                 goto end;
             }
-            
+
+            Status = insert_tree_item(Vcb, Vcb->extent_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, bgi, tp.item->size, NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
+                ExFreePool(bgi);
+                ExReleaseResourceLite(&c->lock);
+                goto end;
+            }
+
             TRACE("bytes_used = %llx\n", Vcb->superblock.bytes_used);
-            
+
             Vcb->superblock.bytes_used += c->used - c->oldused;
-            
+
             TRACE("bytes_used = %llx\n", Vcb->superblock.bytes_used);
-            
+
             c->oldused = c->used;
         }
-        
+
         ExReleaseResourceLite(&c->lock);
-        
+
         le = le->Flink;
     }
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     ExReleaseResourceLite(&Vcb->chunk_lock);
-    
+
     return Status;
 }
 
 static void get_first_item(tree* t, KEY* key) {
     LIST_ENTRY* le;
-    
+
     le = t->itemlist.Flink;
     while (le != &t->itemlist) {
         tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
@@ -2251,136 +2797,66 @@
     }
 }
 
-static NTSTATUS STDCALL split_tree_at(device_extension* Vcb, tree* t, tree_data* newfirstitem, UINT32 numitems, UINT32 size) {
+static NTSTATUS split_tree_at(device_extension* Vcb, tree* t, tree_data* newfirstitem, UINT32 numitems, UINT32 size) {
     tree *nt, *pt;
     tree_data* td;
     tree_data* oldlastitem;
-//     write_tree* wt2;
-// //     tree_data *firsttd, *lasttd;
-// //     LIST_ENTRY* le;
-// #ifdef DEBUG_PARANOID
-//     KEY lastkey1, lastkey2;
-//     traverse_ptr tp, next_tp;
-//     ULONG numitems1, numitems2;
-// #endif
-    
+
     TRACE("splitting tree in %llx at (%llx,%x,%llx)\n", t->root->id, newfirstitem->key.obj_id, newfirstitem->key.obj_type, newfirstitem->key.offset);
-    
-// #ifdef DEBUG_PARANOID
-//     lastkey1.obj_id = 0xffffffffffffffff;
-//     lastkey1.obj_type = 0xff;
-//     lastkey1.offset = 0xffffffffffffffff;
-//     
-//     if (!find_item(Vcb, t->root, &tp, &lastkey1, NULL, FALSE))
-//         ERR("error - find_item failed\n");
-//     else {
-//         lastkey1 = tp.item->key;
-//         numitems1 = 0;
-//         while (find_prev_item(Vcb, &tp, &next_tp, NULL, FALSE)) {
-//             free_traverse_ptr(&tp);
-//             tp = next_tp;
-//             numitems1++;
-//         }
-//         free_traverse_ptr(&tp);
-//     }
-// #endif
-    
+
     nt = ExAllocatePoolWithTag(PagedPool, sizeof(tree), ALLOC_TAG);
     if (!nt) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     RtlCopyMemory(&nt->header, &t->header, sizeof(tree_header));
     nt->header.address = 0;
     nt->header.generation = Vcb->superblock.generation;
     nt->header.num_items = t->header.num_items - numitems;
     nt->header.flags = HEADER_FLAG_MIXED_BACKREF | HEADER_FLAG_WRITTEN;
-    
+
     nt->has_address = FALSE;
     nt->Vcb = Vcb;
     nt->parent = t->parent;
-    
+
 #ifdef DEBUG_PARANOID
     if (nt->parent && nt->parent->header.level <= nt->header.level) int3;
 #endif
-    
+
     nt->root = t->root;
-//     nt->nonpaged = ExAllocatePoolWithTag(NonPagedPool, sizeof(tree_nonpaged), ALLOC_TAG);
     nt->new_address = 0;
     nt->has_new_address = FALSE;
     nt->updated_extents = FALSE;
+    nt->uniqueness_determined = TRUE;
+    nt->is_unique = TRUE;
     nt->list_entry_hash.Flink = NULL;
+    nt->buf = NULL;
     InitializeListHead(&nt->itemlist);
-    
-//     ExInitializeResourceLite(&nt->nonpaged->load_tree_lock);
-    
+
     oldlastitem = CONTAINING_RECORD(newfirstitem->list_entry.Blink, tree_data, list_entry);
 
-// //     firsttd = CONTAINING_RECORD(wt->tree->itemlist.Flink, tree_data, list_entry);
-// //     lasttd = CONTAINING_RECORD(wt->tree->itemlist.Blink, tree_data, list_entry);
-// //     
-// //     TRACE("old tree in %x was from (%x,%x,%x) to (%x,%x,%x)\n",
-// //                   (UINT32)wt->tree->root->id, (UINT32)firsttd->key.obj_id, firsttd->key.obj_type, (UINT32)firsttd->key.offset,
-// //                   (UINT32)lasttd->key.obj_id, lasttd->key.obj_type, (UINT32)lasttd->key.offset);
-// //     
-// //     le = wt->tree->itemlist.Flink;
-// //     while (le != &wt->tree->itemlist) {
-// //         td = CONTAINING_RECORD(le, tree_data, list_entry);
-// //         TRACE("old tree item was (%x,%x,%x)\n", (UINT32)td->key.obj_id, td->key.obj_type, (UINT32)td->key.offset);
-// //         le = le->Flink;
-// //     }
-    
     nt->itemlist.Flink = &newfirstitem->list_entry;
     nt->itemlist.Blink = t->itemlist.Blink;
     nt->itemlist.Flink->Blink = &nt->itemlist;
     nt->itemlist.Blink->Flink = &nt->itemlist;
-    
+
     t->itemlist.Blink = &oldlastitem->list_entry;
     t->itemlist.Blink->Flink = &t->itemlist;
-    
-// //     le = wt->tree->itemlist.Flink;
-// //     while (le != &wt->tree->itemlist) {
-// //         td = CONTAINING_RECORD(le, tree_data, list_entry);
-// //         TRACE("old tree item now (%x,%x,%x)\n", (UINT32)td->key.obj_id, td->key.obj_type, (UINT32)td->key.offset);
-// //         le = le->Flink;
-// //     }
-// //     
-// //     firsttd = CONTAINING_RECORD(wt->tree->itemlist.Flink, tree_data, list_entry);
-// //     lasttd = CONTAINING_RECORD(wt->tree->itemlist.Blink, tree_data, list_entry);
-// //     
-// //     TRACE("old tree in %x is now from (%x,%x,%x) to (%x,%x,%x)\n",
-// //                   (UINT32)wt->tree->root->id, (UINT32)firsttd->key.obj_id, firsttd->key.obj_type, (UINT32)firsttd->key.offset,
-// //                   (UINT32)lasttd->key.obj_id, lasttd->key.obj_type, (UINT32)lasttd->key.offset);
-    
+
     nt->size = t->size - size;
     t->size = size;
     t->header.num_items = numitems;
     nt->write = TRUE;
-    
-    InterlockedIncrement(&Vcb->open_trees);
+
     InsertTailList(&Vcb->trees, &nt->list_entry);
-    
-// //     // TESTING
-// //     td = wt->tree->items;
-// //     while (td) {
-// //         if (!td->ignore) {
-// //             TRACE("old tree item: (%x,%x,%x)\n", (UINT32)td->key.obj_id, td->key.obj_type, (UINT32)td->key.offset);
-// //         }
-// //         td = td->next;
-// //     }
-    
-// //     oldlastitem->next = NULL;
-// //     wt->tree->lastitem = oldlastitem;
-    
-// //     TRACE("last item is now (%x,%x,%x)\n", (UINT32)oldlastitem->key.obj_id, oldlastitem->key.obj_type, (UINT32)oldlastitem->key.offset);
-    
+
     if (nt->header.level > 0) {
         LIST_ENTRY* le = nt->itemlist.Flink;
-        
+
         while (le != &nt->itemlist) {
             tree_data* td2 = CONTAINING_RECORD(le, tree_data, list_entry);
-            
+
             if (td2->treeholder.tree) {
                 td2->treeholder.tree->parent = nt;
 #ifdef DEBUG_PARANOID
@@ -2387,11 +2863,32 @@
                 if (td2->treeholder.tree->parent && td2->treeholder.tree->parent->header.level <= td2->treeholder.tree->header.level) int3;
 #endif
             }
-            
+
             le = le->Flink;
         }
+    } else {
+        LIST_ENTRY* le = nt->itemlist.Flink;
+
+        while (le != &nt->itemlist) {
+            tree_data* td2 = CONTAINING_RECORD(le, tree_data, list_entry);
+
+            if (!td2->inserted && td2->data) {
+                UINT8* data = ExAllocatePoolWithTag(PagedPool, td2->size, ALLOC_TAG);
+
+                if (!data) {
+                    ERR("out of memory\n");
+                    return STATUS_INSUFFICIENT_RESOURCES;
+                }
+
+                RtlCopyMemory(data, td2->data, td2->size);
+                td2->data = data;
+                td2->inserted = TRUE;
+            }
+
+            le = le->Flink;
+        }
     }
-    
+
     if (nt->parent) {
         td = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
         if (!td) {
@@ -2398,42 +2895,41 @@
             ERR("out of memory\n");
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-    
+
         td->key = newfirstitem->key;
-        
+
         InsertHeadList(&t->paritem->list_entry, &td->list_entry);
-        
+
         td->ignore = FALSE;
         td->inserted = TRUE;
         td->treeholder.tree = nt;
-//         td->treeholder.nonpaged->status = tree_holder_loaded;
         nt->paritem = td;
-        
+
         nt->parent->header.num_items++;
         nt->parent->size += sizeof(internal_node);
 
         goto end;
     }
-    
+
     TRACE("adding new tree parent\n");
-    
+
     if (nt->header.level == 255) {
         ERR("cannot add parent to tree at level 255\n");
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     pt = ExAllocatePoolWithTag(PagedPool, sizeof(tree), ALLOC_TAG);
     if (!pt) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     RtlCopyMemory(&pt->header, &nt->header, sizeof(tree_header));
     pt->header.address = 0;
     pt->header.num_items = 2;
     pt->header.level = nt->header.level + 1;
     pt->header.flags = HEADER_FLAG_MIXED_BACKREF | HEADER_FLAG_WRITTEN;
-    
+
     pt->has_address = FALSE;
     pt->Vcb = Vcb;
     pt->parent = NULL;
@@ -2442,22 +2938,21 @@
     pt->new_address = 0;
     pt->has_new_address = FALSE;
     pt->updated_extents = FALSE;
-//     pt->nonpaged = ExAllocatePoolWithTag(NonPagedPool, sizeof(tree_nonpaged), ALLOC_TAG);
     pt->size = pt->header.num_items * sizeof(internal_node);
+    pt->uniqueness_determined = TRUE;
+    pt->is_unique = TRUE;
     pt->list_entry_hash.Flink = NULL;
+    pt->buf = NULL;
     InitializeListHead(&pt->itemlist);
-    
-//     ExInitializeResourceLite(&pt->nonpaged->load_tree_lock);
-    
-    InterlockedIncrement(&Vcb->open_trees);
+
     InsertTailList(&Vcb->trees, &pt->list_entry);
-    
+
     td = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
     if (!td) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     get_first_item(t, &td->key);
     td->ignore = FALSE;
     td->inserted = FALSE;
@@ -2464,16 +2959,15 @@
     td->treeholder.address = 0;
     td->treeholder.generation = Vcb->superblock.generation;
     td->treeholder.tree = t;
-//     td->treeholder.nonpaged->status = tree_holder_loaded;
     InsertTailList(&pt->itemlist, &td->list_entry);
     t->paritem = td;
-    
+
     td = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
     if (!td) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     td->key = newfirstitem->key;
     td->ignore = FALSE;
     td->inserted = FALSE;
@@ -2480,79 +2974,53 @@
     td->treeholder.address = 0;
     td->treeholder.generation = Vcb->superblock.generation;
     td->treeholder.tree = nt;
-//     td->treeholder.nonpaged->status = tree_holder_loaded;
     InsertTailList(&pt->itemlist, &td->list_entry);
     nt->paritem = td;
-    
+
     pt->write = TRUE;
 
     t->root->treeholder.tree = pt;
-    
+
     t->parent = pt;
     nt->parent = pt;
-    
+
 #ifdef DEBUG_PARANOID
     if (t->parent && t->parent->header.level <= t->header.level) int3;
     if (nt->parent && nt->parent->header.level <= nt->header.level) int3;
 #endif
-    
+
 end:
     t->root->root_item.bytes_used += Vcb->superblock.node_size;
 
-// #ifdef DEBUG_PARANOID
-//     lastkey2.obj_id = 0xffffffffffffffff;
-//     lastkey2.obj_type = 0xff;
-//     lastkey2.offset = 0xffffffffffffffff;
-//     
-//     if (!find_item(Vcb, wt->tree->root, &tp, &lastkey2, NULL, FALSE))
-//         ERR("error - find_item failed\n");
-//     else {    
-//         lastkey2 = tp.item->key;
-//         
-//         numitems2 = 0;
-//         while (find_prev_item(Vcb, &tp, &next_tp, NULL, FALSE)) {
-//             free_traverse_ptr(&tp);
-//             tp = next_tp;
-//             numitems2++;
-//         }
-//         free_traverse_ptr(&tp);
-//     }
-//     
-//     ERR("lastkey1 = %llx,%x,%llx\n", lastkey1.obj_id, lastkey1.obj_type, lastkey1.offset);
-//     ERR("lastkey2 = %llx,%x,%llx\n", lastkey2.obj_id, lastkey2.obj_type, lastkey2.offset);
-//     ERR("numitems1 = %u\n", numitems1);
-//     ERR("numitems2 = %u\n", numitems2);
-// #endif
-    
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL split_tree(device_extension* Vcb, tree* t) {
+static NTSTATUS split_tree(device_extension* Vcb, tree* t) {
     LIST_ENTRY* le;
     UINT32 size, ds, numitems;
-    
+
     size = 0;
     numitems = 0;
-    
+
     // FIXME - naïve implementation: maximizes number of filled trees
-    
+
     le = t->itemlist.Flink;
     while (le != &t->itemlist) {
         tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
-        
+
         if (!td->ignore) {
             if (t->header.level == 0)
                 ds = sizeof(leaf_node) + td->size;
             else
                 ds = sizeof(internal_node);
-            
+
             if (numitems == 0 && ds > Vcb->superblock.node_size - sizeof(tree_header)) {
                 ERR("(%llx,%x,%llx) in tree %llx is too large (%x > %x)\n",
                     td->key.obj_id, td->key.obj_type, td->key.offset, t->root->id,
                     ds, Vcb->superblock.node_size - sizeof(tree_header));
-                int3;
+                return STATUS_INTERNAL_ERROR;
             }
-            
+
             // FIXME - move back if previous item was deleted item with same key
             if (size + ds > Vcb->superblock.node_size - sizeof(tree_header))
                 return split_tree_at(Vcb, t, td, numitems, size);
@@ -2560,10 +3028,10 @@
             size += ds;
             numitems++;
         }
-        
+
         le = le->Flink;
     }
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -2571,102 +3039,105 @@
     KEY searchkey;
     traverse_ptr tp;
     NTSTATUS Status;
-    
-    do {
-        EXTENT_ITEM* ei;
-        UINT8* type;
-        
-        if (t->has_address) {
-            searchkey.obj_id = t->header.address;
-            searchkey.obj_type = Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA ? TYPE_METADATA_ITEM : TYPE_EXTENT_ITEM;
-            searchkey.offset = 0xffffffffffffffff;
-            
-            Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
-            if (!NT_SUCCESS(Status)) {
-                ERR("error - find_item returned %08x\n", Status);
-                return FALSE;
-            }
-            
-            if (tp.item->key.obj_id != t->header.address || (tp.item->key.obj_type != TYPE_METADATA_ITEM && tp.item->key.obj_type != TYPE_EXTENT_ITEM))
-                return FALSE;
-            
-            if (tp.item->key.obj_type == TYPE_EXTENT_ITEM && tp.item->size == sizeof(EXTENT_ITEM_V0))
-                return FALSE;
-            
-            if (tp.item->size < sizeof(EXTENT_ITEM))
-                return FALSE;
-            
-            ei = (EXTENT_ITEM*)tp.item->data;
-            
-            if (ei->refcount > 1)
-                return FALSE;
-            
-            if (tp.item->key.obj_type == TYPE_EXTENT_ITEM && ei->flags & EXTENT_ITEM_TREE_BLOCK) {
-                EXTENT_ITEM2* ei2;
-                
-                if (tp.item->size < sizeof(EXTENT_ITEM) + sizeof(EXTENT_ITEM2))
-                    return FALSE;
-                
-                ei2 = (EXTENT_ITEM2*)&ei[1];
-                type = (UINT8*)&ei2[1];
-            } else
-                type = (UINT8*)&ei[1];
-            
-            if (type >= tp.item->data + tp.item->size || *type != TYPE_TREE_BLOCK_REF)
-                return FALSE;
+    BOOL ret = FALSE;
+    EXTENT_ITEM* ei;
+    UINT8* type;
+
+    if (t->uniqueness_determined)
+        return t->is_unique;
+
+    if (t->parent && !is_tree_unique(Vcb, t->parent, Irp))
+        goto end;
+
+    if (t->has_address) {
+        searchkey.obj_id = t->header.address;
+        searchkey.obj_type = Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA ? TYPE_METADATA_ITEM : TYPE_EXTENT_ITEM;
+        searchkey.offset = 0xffffffffffffffff;
+
+        Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("error - find_item returned %08x\n", Status);
+            goto end;
         }
-        
-        t = t->parent;
-    } while (t);
-    
-    return TRUE;
+
+        if (tp.item->key.obj_id != t->header.address || (tp.item->key.obj_type != TYPE_METADATA_ITEM && tp.item->key.obj_type != TYPE_EXTENT_ITEM))
+            goto end;
+
+        if (tp.item->key.obj_type == TYPE_EXTENT_ITEM && tp.item->size == sizeof(EXTENT_ITEM_V0))
+            goto end;
+
+        if (tp.item->size < sizeof(EXTENT_ITEM))
+            goto end;
+
+        ei = (EXTENT_ITEM*)tp.item->data;
+
+        if (ei->refcount > 1)
+            goto end;
+
+        if (tp.item->key.obj_type == TYPE_EXTENT_ITEM && ei->flags & EXTENT_ITEM_TREE_BLOCK) {
+            EXTENT_ITEM2* ei2;
+
+            if (tp.item->size < sizeof(EXTENT_ITEM) + sizeof(EXTENT_ITEM2))
+                goto end;
+
+            ei2 = (EXTENT_ITEM2*)&ei[1];
+            type = (UINT8*)&ei2[1];
+        } else
+            type = (UINT8*)&ei[1];
+
+        if (type >= tp.item->data + tp.item->size || *type != TYPE_TREE_BLOCK_REF)
+            goto end;
+    }
+
+    ret = TRUE;
+
+end:
+    t->is_unique = ret;
+    t->uniqueness_determined = TRUE;
+
+    return ret;
 }
 
-static NTSTATUS try_tree_amalgamate(device_extension* Vcb, tree* t, BOOL* done, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS try_tree_amalgamate(device_extension* Vcb, tree* t, BOOL* done, BOOL* done_deletions, PIRP Irp, LIST_ENTRY* rollback) {
     LIST_ENTRY* le;
     tree_data* nextparitem = NULL;
     NTSTATUS Status;
     tree *next_tree, *par;
     BOOL loaded;
-    
+
     *done = FALSE;
-    
+
     TRACE("trying to amalgamate tree in root %llx, level %x (size %u)\n", t->root->id, t->header.level, t->size);
-    
+
     // FIXME - doesn't capture everything, as it doesn't ascend
     le = t->paritem->list_entry.Flink;
     while (le != &t->parent->itemlist) {
         tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
-        
+
         if (!td->ignore) {
             nextparitem = td;
             break;
         }
-        
+
         le = le->Flink;
     }
-    
+
     if (!nextparitem)
         return STATUS_SUCCESS;
-    
+
     TRACE("nextparitem: key = %llx,%x,%llx\n", nextparitem->key.obj_id, nextparitem->key.obj_type, nextparitem->key.offset);
-//     nextparitem = t->paritem;
-    
-//     ExAcquireResourceExclusiveLite(&t->parent->nonpaged->load_tree_lock, TRUE);
-    
+
     Status = do_load_tree(Vcb, &nextparitem->treeholder, t->root, t->parent, nextparitem, &loaded, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("do_load_tree returned %08x\n", Status);
         return Status;
     }
-    
+
     if (!is_tree_unique(Vcb, nextparitem->treeholder.tree, Irp))
         return STATUS_SUCCESS;
-    
-//     ExReleaseResourceLite(&t->parent->nonpaged->load_tree_lock);
-    
+
     next_tree = nextparitem->treeholder.tree;
-    
+
     if (!next_tree->updated_extents && next_tree->has_address) {
         Status = update_tree_extents(Vcb, next_tree, Irp, rollback);
         if (!NT_SUCCESS(Status)) {
@@ -2674,19 +3145,19 @@
             return Status;
         }
     }
-    
+
     if (t->size + next_tree->size <= Vcb->superblock.node_size - sizeof(tree_header)) {
         // merge two trees into one
-        
+
         t->header.num_items += next_tree->header.num_items;
         t->size += next_tree->size;
-        
+
         if (next_tree->header.level > 0) {
             le = next_tree->itemlist.Flink;
-            
+
             while (le != &next_tree->itemlist) {
                 tree_data* td2 = CONTAINING_RECORD(le, tree_data, list_entry);
-                
+
                 if (td2->treeholder.tree) {
                     td2->treeholder.tree->parent = t;
 #ifdef DEBUG_PARANOID
@@ -2693,33 +3164,46 @@
                     if (td2->treeholder.tree->parent && td2->treeholder.tree->parent->header.level <= td2->treeholder.tree->header.level) int3;
 #endif
                 }
-                
+
+                td2->inserted = TRUE;
                 le = le->Flink;
             }
+        } else {
+            le = next_tree->itemlist.Flink;
+
+            while (le != &next_tree->itemlist) {
+                tree_data* td2 = CONTAINING_RECORD(le, tree_data, list_entry);
+
+                if (!td2->inserted && td2->data) {
+                    UINT8* data = ExAllocatePoolWithTag(PagedPool, td2->size, ALLOC_TAG);
+
+                    if (!data) {
+                        ERR("out of memory\n");
+                        return STATUS_INSUFFICIENT_RESOURCES;
+                    }
+
+                    RtlCopyMemory(data, td2->data, td2->size);
+                    td2->data = data;
+                    td2->inserted = TRUE;
+                }
+
+                le = le->Flink;
+            }
         }
-        
-        le = next_tree->itemlist.Flink;
-        while (le != &next_tree->itemlist) {
-            tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
-            
-            td->inserted = TRUE;
-            
-            le = le->Flink;
-        }
-        
+
         t->itemlist.Blink->Flink = next_tree->itemlist.Flink;
         t->itemlist.Blink->Flink->Blink = t->itemlist.Blink;
         t->itemlist.Blink = next_tree->itemlist.Blink;
         t->itemlist.Blink->Flink = &t->itemlist;
-        
+
         next_tree->itemlist.Flink = next_tree->itemlist.Blink = &next_tree->itemlist;
-        
+
         next_tree->header.num_items = 0;
         next_tree->size = 0;
-        
+
         if (next_tree->has_new_address) { // delete associated EXTENT_ITEM
             Status = reduce_tree_extent(Vcb, next_tree->new_address, next_tree, next_tree->parent->header.tree_id, next_tree->header.level, Irp, rollback);
-            
+
             if (!NT_SUCCESS(Status)) {
                 ERR("reduce_tree_extent returned %08x\n", Status);
                 return Status;
@@ -2726,33 +3210,35 @@
             }
         } else if (next_tree->has_address) {
             Status = reduce_tree_extent(Vcb, next_tree->header.address, next_tree, next_tree->parent->header.tree_id, next_tree->header.level, Irp, rollback);
-            
+
             if (!NT_SUCCESS(Status)) {
                 ERR("reduce_tree_extent returned %08x\n", Status);
                 return Status;
             }
         }
-        
+
         if (!nextparitem->ignore) {
             nextparitem->ignore = TRUE;
             next_tree->parent->header.num_items--;
             next_tree->parent->size -= sizeof(internal_node);
+
+            *done_deletions = TRUE;
         }
-        
+
         par = next_tree->parent;
         while (par) {
             par->write = TRUE;
             par = par->parent;
         }
-        
+
         RemoveEntryList(&nextparitem->list_entry);
         ExFreePool(next_tree->paritem);
         next_tree->paritem = NULL;
-        
+
         next_tree->root->root_item.bytes_used -= Vcb->superblock.node_size;
-        
+
         free_tree(next_tree);
-        
+
         *done = TRUE;
     } else {
         // rebalance by moving items from second tree into first
@@ -2759,14 +3245,14 @@
         ULONG avg_size = (t->size + next_tree->size) / 2;
         KEY firstitem = {0, 0, 0};
         BOOL changed = FALSE;
-        
+
         TRACE("attempting rebalance\n");
-        
+
         le = next_tree->itemlist.Flink;
         while (le != &next_tree->itemlist && t->size < avg_size && next_tree->header.num_items > 1) {
             tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
             ULONG size;
-            
+
             if (!td->ignore) {
                 if (next_tree->header.level == 0)
                     size = sizeof(leaf_node) + td->size;
@@ -2774,19 +3260,30 @@
                     size = sizeof(internal_node);
             } else
                 size = 0;
-            
+
             if (t->size + size < Vcb->superblock.node_size - sizeof(tree_header)) {
                 RemoveEntryList(&td->list_entry);
                 InsertTailList(&t->itemlist, &td->list_entry);
-                td->inserted = TRUE;
-                
+
                 if (next_tree->header.level > 0 && td->treeholder.tree) {
                     td->treeholder.tree->parent = t;
 #ifdef DEBUG_PARANOID
                     if (td->treeholder.tree->parent && td->treeholder.tree->parent->header.level <= td->treeholder.tree->header.level) int3;
 #endif
+                } else if (next_tree->header.level == 0 && !td->inserted && td->size > 0) {
+                    UINT8* data = ExAllocatePoolWithTag(PagedPool, td->size, ALLOC_TAG);
+
+                    if (!data) {
+                        ERR("out of memory\n");
+                        return STATUS_INSUFFICIENT_RESOURCES;
+                    }
+
+                    RtlCopyMemory(data, td->data, td->size);
+                    td->data = data;
                 }
-                
+
+                td->inserted = TRUE;
+
                 if (!td->ignore) {
                     next_tree->size -= size;
                     t->size += size;
